coccicheck 6.2 KB

123456789101112131415161718192021222324252627282930313233343536373839404142434445464748495051525354555657585960616263646566676869707172737475767778798081828384858687888990919293949596979899100101102103104105106107108109110111112113114115116117118119120121122123124125126127128129130131132133134135136137138139140141142143144145146147148149150151152153154155156157158159160161162163164165166167168169170171172173174175176177178179180181182183184185186187188189190191192193194195196197198199200201202203204205206207208209210211212213214215216217218219220221222223224225226227228229230231232233234235236237238239240241242243
  1. #!/bin/bash
  2. # SPDX-License-Identifier: GPL-2.0
  3. #
  4. ZEPHYR_BASE=$( builtin cd "$( dirname "$DIR" )" && pwd ${PWD_OPT})
  5. DIR="$(dirname $(readlink -f $0))/.."
  6. SPATCH="`which ${SPATCH:=spatch}`"
  7. if [ ! -x "$SPATCH" ]; then
  8. echo 'spatch is part of the Coccinelle project and is available at http://coccinelle.lip6.fr/'
  9. exit 1
  10. fi
  11. VERBOSE=0
  12. usage="Usage: ./scripts/coccicheck [OPTIONS]... [DIRECTORY|FILE]...
  13. OPTIONS:
  14. -------
  15. -m= , --mode= specify the mode use {report, patch, org, context, chain}
  16. -v= , --verbose= enable verbose output {1}
  17. -j= , --jobs= number of jobs to use {0 - `nproc`}
  18. -c= , --cocci= specify cocci script to use
  19. -d= , --debug= specify file to store debug log
  20. -f= , --sp-flag= pass additional flag to spatch
  21. -h , --help display help and exit
  22. Default values if any OPTION is not supplied:
  23. --------------------------------------------
  24. mode = report
  25. verbose = 0 (disabled)
  26. jobs = maximum jobs available on the machine
  27. cocci = all cocci scripts available at scripts/coccinelle/*
  28. If no [DIRECTORY|FILE] is supplied, entire codebase is processed.
  29. For detailed documentation refer: doc/guides/coccinelle.rst"
  30. for i in "$@"
  31. do
  32. case $i in
  33. -m=*|--mode=*)
  34. MODE="${i#*=}"
  35. shift # past argument=value
  36. ;;
  37. -v=*|--verbose=*)
  38. VERBOSE="${i#*=}"
  39. shift # past argument=value
  40. ;;
  41. -j=*|--jobs=*)
  42. J="${i#*=}"
  43. shift
  44. ;;
  45. -c=*|--cocci=*)
  46. COCCI="${i#*=}"
  47. shift
  48. ;;
  49. -d=*|--debug=*)
  50. DEBUG_FILE="${i#*=}"
  51. shift
  52. ;;
  53. -f=*|--sp-flag=*)
  54. SPFLAGS="${i#*=}"
  55. shift
  56. ;;
  57. -h|--help)
  58. echo "$usage"
  59. exit 1
  60. ;;
  61. *)
  62. FILE="${i#*=}"
  63. if [ ! -e "$FILE" ]; then
  64. echo "unknown option: '${i#*=}'"
  65. echo "$usage"
  66. exit 2
  67. fi
  68. ;;
  69. esac
  70. done
  71. FLAGS="--very-quiet"
  72. if [ "$FILE" = "" ] ; then
  73. OPTIONS="--dir $ZEPHYR_BASE"
  74. else
  75. OPTIONS="--dir $FILE"
  76. fi
  77. if [ -z "$J" ]; then
  78. NPROC=$(getconf _NPROCESSORS_ONLN)
  79. else
  80. NPROC="$J"
  81. fi
  82. OPTIONS="--macro-file $ZEPHYR_BASE/scripts/coccinelle/macros.h $OPTIONS"
  83. if [ "$FILE" != "" ] ; then
  84. OPTIONS="--patch $ZEPHYR_BASE $OPTIONS"
  85. fi
  86. if [ "$NPROC" != "1" ]; then
  87. # Using 0 should work as well, refer to _SC_NPROCESSORS_ONLN use on
  88. # https://github.com/rdicosmo/parmap/blob/master/setcore_stubs.c
  89. OPTIONS="$OPTIONS --jobs $NPROC --chunksize 1"
  90. fi
  91. if [ "$MODE" = "" ] ; then
  92. echo 'You have not explicitly specified the mode to use. Using default "report" mode.'
  93. echo 'Available modes are the following: 'patch', 'report', 'context', 'org''
  94. echo 'You can specify the mode with "./scripts/coccicheck --mode=<mode>"'
  95. echo 'Note however that some modes are not implemented by some semantic patches.'
  96. MODE="report"
  97. fi
  98. if [ "$MODE" = "chain" ] ; then
  99. echo 'You have selected the "chain" mode.'
  100. echo 'All available modes will be tried (in that order): patch, report, context, org'
  101. elif [ "$MODE" = "report" -o "$MODE" = "org" ] ; then
  102. FLAGS="--no-show-diff $FLAGS"
  103. fi
  104. echo ''
  105. echo 'Please check for false positives in the output before submitting a patch.'
  106. echo 'When using "patch" mode, carefully review the patch before submitting it.'
  107. echo ''
  108. run_cmd_parmap() {
  109. if [ $VERBOSE -ne 0 ] ; then
  110. echo "Running ($NPROC in parallel): $@"
  111. fi
  112. echo $@ >>$DEBUG_FILE
  113. $@ 2>>$DEBUG_FILE
  114. err=$?
  115. if [[ $err -ne 0 ]]; then
  116. echo "coccicheck failed"
  117. exit $err
  118. fi
  119. }
  120. # You can override heuristics with SPFLAGS, these must always go last
  121. OPTIONS="$OPTIONS $SPFLAGS"
  122. coccinelle () {
  123. COCCI="$1"
  124. OPT=`grep "Options:" $COCCI | cut -d':' -f2`
  125. VIRTUAL=`grep "virtual" $COCCI | cut -d' ' -f2`
  126. if [[ $VIRTUAL = "" ]]; then
  127. echo "No available modes found in \"$COCCI\" script."
  128. echo "Consider adding virtual rules to the script."
  129. exit 1
  130. elif [[ $VIRTUAL != *"$MODE"* ]]; then
  131. echo "Invalid mode \"$MODE\" supplied!"
  132. echo "Available modes for \"`basename $COCCI`\" are: "$VIRTUAL""
  133. if [[ $VIRTUAL == *report* ]]; then
  134. MODE=report
  135. elif [[ $VIRTUAL == *context* ]]; then
  136. MODE=context
  137. elif [[ $VIRTUAL == *patch* ]]; then
  138. MODE=patch
  139. else
  140. MODE=org
  141. fi
  142. echo "Using random available mode: \"$MODE\""
  143. echo ''
  144. fi
  145. if [ $VERBOSE -ne 0 ] ; then
  146. FILE=${COCCI#$ZEPHYR_BASE/}
  147. echo "Processing `basename $COCCI`"
  148. echo "with option(s) \"$OPT\""
  149. echo ''
  150. echo 'Message example to submit a patch:'
  151. sed -ne 's|^///||p' $COCCI
  152. if [ "$MODE" = "patch" ] ; then
  153. echo ' The semantic patch that makes this change is available'
  154. elif [ "$MODE" = "report" ] ; then
  155. echo ' The semantic patch that makes this report is available'
  156. elif [ "$MODE" = "context" ] ; then
  157. echo ' The semantic patch that spots this code is available'
  158. elif [ "$MODE" = "org" ] ; then
  159. echo ' The semantic patch that makes this Org report is available'
  160. else
  161. echo ' The semantic patch that makes this output is available'
  162. fi
  163. echo " in $FILE."
  164. echo ''
  165. echo ' More information about semantic patching is available at'
  166. echo ' http://coccinelle.lip6.fr/'
  167. echo ''
  168. if [ "`sed -ne 's|^//#||p' $COCCI`" ] ; then
  169. echo 'Semantic patch information:'
  170. sed -ne 's|^//#||p' $COCCI
  171. echo ''
  172. fi
  173. fi
  174. if [ "$MODE" = "chain" ] ; then
  175. run_cmd_parmap $SPATCH -D patch \
  176. $FLAGS --cocci-file $COCCI $OPT $OPTIONS || \
  177. run_cmd_parmap $SPATCH -D report \
  178. $FLAGS --cocci-file $COCCI $OPT $OPTIONS --no-show-diff || \
  179. run_cmd_parmap $SPATCH -D context \
  180. $FLAGS --cocci-file $COCCI $OPT $OPTIONS || \
  181. run_cmd_parmap $SPATCH -D org \
  182. $FLAGS --cocci-file $COCCI $OPT $OPTIONS --no-show-diff || exit 1
  183. elif [ "$MODE" = "rep+ctxt" ] ; then
  184. run_cmd_parmap $SPATCH -D report \
  185. $FLAGS --cocci-file $COCCI $OPT $OPTIONS --no-show-diff && \
  186. run_cmd_parmap $SPATCH -D context \
  187. $FLAGS --cocci-file $COCCI $OPT $OPTIONS || exit 1
  188. else
  189. run_cmd_parmap $SPATCH -D $MODE $FLAGS --cocci-file $COCCI $OPT $OPTIONS || exit 1
  190. fi
  191. MODE=report
  192. }
  193. if [ "$DEBUG_FILE" != "/dev/null" -a "$DEBUG_FILE" != "" ]; then
  194. if [ -f $DEBUG_FILE ]; then
  195. echo "Debug file \"$DEBUG_FILE\" exists, bailing ..."
  196. exit
  197. fi
  198. else
  199. DEBUG_FILE="/dev/null"
  200. fi
  201. if [ "$COCCI" = "" ] ; then
  202. for f in `find $ZEPHYR_BASE/scripts/coccinelle/ -name '*.cocci' -type f | sort`; do
  203. coccinelle $f
  204. echo '-------------------------------------------------------------------------'
  205. echo ''
  206. done
  207. else
  208. coccinelle $COCCI
  209. fi